;------- SIDwinder Packer V01.20 -------


         *= $0810

z2b      = $2b
z2c      = $2c
z2d      = $2d
z2e      = $2e
z2f      = $2f
screen   = $e000
messln   = $0541

         jmp startp

getkey   lda #$00          ;empty
         sta $c6           ;buffer
         lda $c6
         beq *-2
         lda $0277
         cmp #$0d          ;return
         beq cont01
         cmp #$14          ;delete
         beq cont01
         cmp #$20
         bcc getkey
         cmp #$60
         bcs getkey
cont01   rts

msgwrt   lda msgadl,y      ;message #y
         sta $f9
         lda #$e4
         sta $fa
         ldy #$25
         sei
         lda #$35
         sta $01
msglop   lda ($f9),y
         sta messln,y
         dey
         bpl msglop
         lda #$36
         sta $01
         cli
         rts

getnam   jsr msgwrt        ;load/save
         lda #$20
         ldy #$0f
         sta filnam,y
clrnam   dey
         bpl clrnam
         ldx #$00          ;length
         ldy #$10          ;shift
cursor   lda #$a0
         sta messln,y
newchr   jsr getkey
         cmp #$0d          ;return
         bne cont04
         cpx #$00
         beq newchr
         lda #$20
         sta messln,y
         ldy #$00
         jmp msgwrt

cont04   cmp #$14          ;delete
         bne cont05
         cpx #$00
         beq newchr
         lda #$20
         sta messln,y
         dex
         sta filnam,x
         dey
         jmp cursor

cont05   cpx #$10          ;char
         beq newchr
         sta filnam,x
         sta messln,y
         inx
         iny
         jmp cursor

numout   pha
         iny
         and #$0f
         jsr numwrt
         pla
         dey
         and #$f0
         lsr a
         lsr a
         lsr a
         lsr a
numwrt   ora #$30
         cmp #$3a
         bcc *+5
         clc
         adc #$07
         sta messln,y
         rts

getnum   jsr msgwrt
         lda #$00
         sta z2f
loop00   lda z2f
         and #$1f
         sta z2f
         tax
         ldy #$1f
         jsr numout
         inx
         stx modnum
notret   jsr getkey
         cmp #$2b
         bne nocrup
         inc z2f
         jmp loop00
nocrup   cmp #$2d
         bne nocrdn
         dec z2f
         jmp loop00
nocrdn   cmp #$0d
         bne notret
         rts

derror   lda #$01          ;disk error
         ldx #$08
         ldy #$0f
         jsr $ffba
         lda #$00
         tax
         tay
         jsr $ffbd
         jsr $ffc0         ;open1,8,15
         ldx #$01
         jsr $ffc6         ;chkin
         ldy #$01
erread   jsr $ffcf         ;input
         cmp #$0d
         beq return
         sta messln,y
         iny
         cpy #$26
         bne erread
return   jsr $ffcc
         lda #$01
         jsr $ffc3
         lda messln+1
         cmp #$30          ;ok?
         rts

presss   jsr getkey
         cmp #$20
         bne presss
         rts

startp   jsr $ff5b         ;vic init
         lda #$0b
         sta $d011         ;blank
         lda #$00
         sta $d020
         sta $d021
         tax
         sei
         lda #$35
         sta $01
scrcpy   lda #$0f
         sta $d800,x
         sta $d900,x
         sta $da00,x
         sta $db00,x
         lda screen,x
         sta $0400,x
         lda screen+$0100,x
         sta $0500,x
         lda screen+$0200,x
         sta $0600,x
         lda screen+$0300,x
         sta $0700,x
         inx
         bne scrcpy
         lda #$36
         sta $01
         cli
         lda #$80
         sta $0291         ;shift-cbm
         lda #$1b
         sta $d011
         lda #$17
         sta $d018
         lda #$00
         jsr $ff90         ;i/o msgs

loadit   ldy #$01          ;load name
         jsr getnam
         txa               ;length
         ldx #LO(filnam)
         ldy #HI(filnam)
         jsr $ffbd         ;filename
         lda #$00
         ldx #$08          ;unit #
         tay               ;sec.addr
         jsr $ffba
         ldx #$00
         ldy #$40          ;to $4000
         jsr $ffd5         ;load
         bcc cont06
         cmp #$05
         bne cont06
         ldy #$05          ;device not
         jsr msgwrt        ;present
         jmp space1

cont06   jsr derror
         beq cont07        ;00 ok
space1   jsr presss
         jmp loadit

cont07   jsr presss
         ldy #$15
pcheck   lda $100a,y       ;player
         cmp $400a,y
         bne no0120
         dey
         bpl pcheck
         jmp *+8
no0120   ldy #$03
         jmp space1

         ldy #$06
         jsr getnum
         ldy #$04
         jsr msgwrt        ;packing...
         lda #$c6          ;8f
         sta z2d
         lda #$16          ;16
         sta z2e

         ldx #$00
loop01   lda $4700,x       ;speeds
         jsr copyit
         inx
         cpx modnum
         bne loop01

set_01   lda z2d
         sta $15eb         ;15b4
         lda z2e
         sta $15ec         ;15b5
         ldx #$00
loop03   lda $4720,x       ;start1
         jsr copyit
         inx
         cpx modnum
         bne loop03

set_02   lda z2d
         sta $15f1         ;15ba
         lda z2e
         sta $15f2         ;15bb
         ldx #$00
loop05   lda $4740,x       ;start2
         jsr copyit
         inx
         cpx modnum
         bne loop05

set_03   lda z2d
         sta $15f7         ;15c0
         lda z2e
         sta $15f8         ;15c1
         ldx #$00
loop07   lda $4760,x       ;start3
         jsr copyit
         inx
         cpx modnum
         bne loop07

set_04   lda z2d
         sta $1484         ;144d
         sta $149e         ;1467
         lda z2e
         sta $1485         ;144e
         sta $149f         ;1468
         ldx #$00
loop09   lda $4840,x       ;gld_al
         jsr copyit
         inx
         cpx #$10
         bne loop09
         lda z2d
         sta $148d         ;1456
         sta $14a7         ;1470
         lda z2e
         sta $148e         ;1457
         sta $14a8         ;1471
         ldx #$00
loop0a   lda $4850,x       ;gld_ah
         jsr copyit
         inx
         cpx #$10
         bne loop0a

         ldx #$3f
loop0b   lda $4940,x       ;snd#
         bne sndfnd
         lda $4980,x
         bne sndfnd
         dex
         bne loop0b
sndfnd   inx
         stx sndnum

         lda z2d
         sta $13d1         ;139a
         lda z2e
         sta $13d2         ;139b
         ldx #$00
loop0c   lda $4940,x       ;ad
         jsr copyit
         inx
         cpx sndnum
         bne loop0c

         lda z2d
         sta $13d7         ;13a0
         lda z2e
         sta $13d8         ;13a1
         ldx #$00
loop0d   lda $4980,x       ;sr
         jsr copyit
         inx
         cpx sndnum
         bne loop0d

         lda z2d
         sta $1326         ;12ef
         lda z2e
         sta $1327         ;12f0
         ldx #$00
loop0e   lda $49c0,x       ;gt
         jsr copyit
         inx
         cpx sndnum
         bne loop0e

         lda z2d
         sta $132c         ;12f5
         lda z2e
         sta $132d         ;12f6
         ldx #$00
loop0f   lda $4a00,x       ;wt
         jsr copyit
         inx
         cpx sndnum
         bne loop0f

         lda z2d
         sta $1361         ;132a
         lda z2e
         sta $1362         ;132b
         ldx #$00
loop10   lda $4a40,x       ;ft
         jsr copyit
         inx
         cpx sndnum
         bne loop10

         lda z2d
         sta $1337         ;1300
         lda z2e
         sta $1338         ;1301
         ldx #$00
loop11   lda $4a80,x       ;pt
         jsr copyit
         inx
         cpx sndnum
         bne loop11

         lda z2d
         sta $134c         ;1315
         lda z2e
         sta $134d         ;1316
         ldx #$00
loop12   lda $4ac0,x       ;st
         jsr copyit
         inx
         cpx sndnum
         bne loop12

         ldx #$ff
loop14   lda $4b00,x       ;wvelen
         bne wvefnd
         dex
         bne loop14
wvefnd   inx
         stx tablen

         lda z2d
         sta $1450         ;1419
         sta $145e         ;1427
         lda z2e
         sta $1451         ;141a
         sta $145f         ;1428
         ldx #$00
loop15   lda $4b00,x       ;wve_wf
         jsr copyit
         inx
         cpx tablen
         bne loop15

         lda z2d
         sta $1457         ;1420
         sta $1472         ;143b
         lda z2e
         sta $1458         ;1421
         sta $1473         ;143c
         ldx #$00
loop16   lda $4c00,x       ;wve_st
         jsr copyit
         inx
         cpx tablen
         bne loop16

         ldx #$ff
loop17   lda $4d00,x       ;fltlen
         bne fltfnd
         dex
         bne loop17
fltfnd   inx
         stx tablen

         lda z2d
         sta $1560         ;1529
         lda z2e
         sta $1561         ;152a
         ldx #$00
loop18   lda $4d00,x       ;flt_rp
         jsr copyit
         inx
         cpx tablen
         bne loop18

         lda z2d
         sta $1569         ;1532
         sta $1573         ;153c
         sta $159e         ;1567
         lda z2e
         sta $156a         ;1533
         sta $1574         ;153d
         sta $159f         ;1568
         ldx #$00
loop19   lda $4e00,x       ;flt_fh
         jsr copyit
         inx
         cpx tablen
         bne loop19

         lda z2d
         sta $158a         ;1553
         lda z2e
         sta $158b         ;1554
         ldx #$00
loop1a   lda $4f00,x       ;flt_rl
         jsr copyit
         inx
         cpx tablen
         bne loop1a

         ldx #$ff
loop1b   lda $5000,x       ;plslen
         bne plsfnd
         dex
         bne loop1b
plsfnd   inx
         stx tablen

         lda z2d
         sta $1412         ;13db
         sta $1420         ;13e9
         lda z2e
         sta $1413         ;13dc
         sta $1421         ;13ea
         ldx #$00
loop1c   lda $5000,x       ;pls_rp
         jsr copyit
         inx
         cpx tablen
         bne loop1c

         lda z2d
         sta $142d         ;13f6
         lda z2e
         sta $142e         ;13f7
         ldx #$00
loop1d   lda $5100,x       ;pls_pl
         jsr copyit
         inx
         cpx tablen
         bne loop1d

         lda z2d
         sta $1419         ;13e2
         sta $1439         ;1402
         lda z2e
         sta $141a         ;13e3
         sta $143a         ;1403
         ldx #$00
loop1e   lda $5200,x       ;pls_ph
         jsr copyit
         inx
         cpx tablen
         bne loop1e

         ldx #$ff
loop1f   lda $5300,x       ;sldlen
         bne sldfnd
         dex
         bne loop1f
sldfnd   inx
         stx tablen

         lda z2d
         sta $14cb         ;1494
         lda z2e
         sta $14cc         ;1495
         ldx #$00
loop20   lda $5300,x       ;sld_rp
         jsr copyit
         inx
         cpx tablen
         bne loop20

         lda z2d
         sta $14e7         ;14b0
         sta $14f7         ;14c0
         lda z2e
         sta $14e8         ;14b1
         sta $14f8         ;14c1
         ldx #$00
loop21   lda $5400,x       ;sld_fl
         jsr copyit
         inx
         cpx tablen
         bne loop21

         lda z2d
         sta $14d4         ;149d
         sta $14e1         ;14aa
         sta $1500         ;14c9
         lda z2e
         sta $14d5         ;149e
         sta $14e2         ;14ab
         sta $1501         ;14ca
         ldx #$00
loop22   lda $5500,x       ;sld_fh
         jsr copyit
         inx
         cpx tablen
         bne loop22

         lda modnum
         cmp #$08
         bcc *+4
         lda #$08
         sta trknum

         ldx #$00          ;track1
loop23   lda $4780,x       ;read
         sta z2b           ;source
         lda $47e0,x
         sta z2c
         lda z2d           ;target
         sta $4780,x       ;write
         sta $4788,x
         sta $4790,x
         sta $4798,x
         lda z2e
         sta $47e0,x
         sta $47e8,x
         sta $47f0,x
         sta $47f8,x
         ldy #$ff
loop24   lda ($2b),y
         cmp #$ff          ;jmp
         beq tr1fnd
         dey
         bne loop24
tr1fnd   iny
         iny
         sty tablen
         ldy #$00
loop25   lda ($2b),y
         jsr copyit
         iny
         cpy tablen
         bne loop25
         inx
         cpx trknum
         bne loop23

         ldx #$00          ;track2
loop26   lda $47a0,x       ;read
         sta z2b           ;source
         lda $4800,x
         sta z2c
         lda z2d           ;target
         sta $47a0,x       ;write
         sta $47a8,x
         sta $47b0,x
         sta $47b8,x
         lda z2e
         sta $4800,x
         sta $4808,x
         sta $4810,x
         sta $4818,x
         ldy #$ff
loop27   lda ($2b),y
         cmp #$ff          ;jmp
         beq tr2fnd
         dey
         bne loop27
tr2fnd   iny
         iny
         sty tablen
         ldy #$00
loop28   lda ($2b),y
         jsr copyit
         iny
         cpy tablen
         bne loop28
         inx
         cpx trknum
         bne loop26

         ldx #$00          ;track3
loop29   lda $47c0,x       ;read
         sta z2b           ;source
         lda $4820,x
         sta z2c
         lda z2d           ;target
         sta $47c0,x       ;write
         sta $47c8,x
         sta $47d0,x
         sta $47d8,x
         lda z2e
         sta $4820,x
         sta $4828,x
         sta $4830,x
         sta $4838,x
         ldy #$ff
loop2a   lda ($2b),y
         cmp #$ff          ;jmp
         beq tr3fnd
         dey
         bne loop2a
tr3fnd   iny
         iny
         sty tablen
         ldy #$00
loop2b   lda ($2b),y
         jsr copyit
         iny
         cpy tablen
         bne loop2b
         inx
         cpx trknum
         bne loop29

         lda #$00          ;sct#
         sta z2b
         lda #$ce
         sta z2c
         ldy #$ff
loop2c   lda ($2b),y
         cmp #$7f          ;end
         beq sctfnd
         dey
         cpy #$ff
         bne loop2c
         dec z2c
         bne loop2c
sctfnd   lda z2c
         sec
         sbc #$6f
         sta sctnum

         ldx #$00          ;sectors
loop2d   lda $4880,x       ;read
         sta z2b           ;source
         lda $48e0,x
         sta z2c
         lda z2d           ;target
         sta $4880,x       ;write
         lda z2e
         sta $48e0,x
         ldy #$ff
loop2e   lda ($2b),y
         cmp #$7f          ;end
         beq endfnd
         dey
         bne loop2e
endfnd   iny
         sty tablen
         ldy #$00
loop2f   lda ($2b),y
         jsr copyit
         iny
         cpy tablen
         bne loop2f
         inx
         cpx sctnum
         bne loop2d

         lda z2d
         sta $15c7         ;1590
         lda z2e
         sta $15c8         ;1591
         ldx #$00
loop30   lda $4780,x       ;tr1adl
         jsr copyit
         inx
         cpx modnum
         bne loop30

set_05   lda z2d
         sta $15cd         ;1596
         lda z2e
         sta $15ce         ;1597
         ldx #$00
loop32   lda $47a0,x       ;tr2adl
         jsr copyit
         inx
         cpx modnum
         bne loop32

set_06   lda z2d
         sta $15d3         ;159c
         lda z2e
         sta $15d4         ;159d
         ldx #$00
loop34   lda $47c0,x       ;tr3adl
         jsr copyit
         inx
         cpx modnum
         bne loop34

set_07   lda z2d
         sta $15d9         ;15a2
         lda z2e
         sta $15da         ;15a3
         ldx #$00
loop36   lda $47e0,x       ;tr1adh
         jsr copyit
         inx
         cpx modnum
         bne loop36

set_08   lda z2d
         sta $15df         ;15a8
         lda z2e
         sta $15e0         ;15a9
         ldx #$00
loop38   lda $4800,x       ;tr2adh
         jsr copyit
         inx
         cpx modnum
         bne loop38

set_09   lda z2d
         sta $15e5         ;15ae
         lda z2e
         sta $15e6         ;15af
         ldx #$00
loop3a   lda $4820,x       ;tr3adh
         jsr copyit
         inx
         cpx modnum
         bne loop3a

set_0a   lda z2d
         sta $1202         ;1202
         sta $1617         ;15e0
         lda z2e
         sta $1203         ;1203
         sta $1618         ;15e1
         ldx #$00
loop3c   lda $4880,x       ;sctadl
         jsr copyit
         inx
         cpx sctnum
         bne loop3c
         lda z2d
         sta $120a         ;120a
         sta $161d         ;15e6
         lda z2e
         sta $120b         ;120b
         sta $161e         ;15e7
         ldx #$00
loop3d   lda $48e0,x       ;sctadh
         jsr copyit
         inx
         cpx sctnum
         bne loop3d
         lda #$00
         jsr copyit
         jsr copyit
         lda modnum
         sta $15c2         ;158b

saveit   ldy #$02          ;save name
         jsr getnam
         txa               ;length
         ldx #LO(filnam)
         ldy #HI(filnam)
         jsr $ffbd         ;filename
         lda #$00
         ldx #$08          ;unit #
         tay               ;sec.addr
         jsr $ffba
         lda #$00          ;from
         sta $fb
         lda #$10
         sta $fc
         lda #$fb
         ldx z2d           ;to
         ldy z2e
         jsr $ffd8         ;later
         bcc cont11
         cmp #$05
         bne cont11
         ldy #$05          ;device not
         jsr msgwrt        ;present
         jmp space2

cont11   jsr derror
         beq cont12        ;00 ok
space2   jsr presss
         jmp saveit

cont12   jsr presss
         lda #$37
         sta $01
         lda #$80          ;quit
         sta $de00
         jmp $fce2

copyit   sty $2f
         ldy #$00
         sta $d020
         sta ($2d),y
         sty $d020
         tay
         dey
         bne *-1
         inc $2d
         bne *+4
         inc $2e
         ldy $2f
         rts


         *= $0f40

modnum   .byte $00         ;modules
trknum   .byte $00         ;tracks
sctnum   .byte $00         ;sectors
sndnum   .byte $00         ;sounds
tablen   .byte $00         ;length
msgadl   .byte $00         ;empty line
         .byte $28         ;load name
         .byte $50         ;save name
         .byte $78         ;not v01.20
         .byte $a0         ;packing...
         .byte $c8         ;device not
         .byte $f0         ;modules
filnam   .text "                "


;--- Finished on 19/07/1994 by Taki ----

